<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/I2CCommander.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('I2CCommander_8cpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">I2CCommander.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Commanders&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;I2C Commander&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifdef NO_I2CCOMMANDER</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#pragma message (&quot;Commanders : No I2C commander !&quot;)</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<a class="code" href="classI2CCommanderClass.html">I2CCommanderClass</a> *I2CCommanderClass::pI2cCommander;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define I2C_BUFFERLENGTH    (sizeof(unsigned long) + 1 + sizeof(int) + 5)</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">// Just here and not in the class, because this value must be updated by a &#39;C&#39; style function, and should be declared public in the class....</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> I2CLastEventId;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keywordtype">void</span> OnReceiveHandler(<span class="keywordtype">int</span> inNbBytes)</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    I2CLastEventId = <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> buf[I2C_BUFFERLENGTH];</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    uint8_t count = 0;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordflow">while</span> (Wire.available() &amp;&amp; count &lt; I2C_BUFFERLENGTH)</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        buf[count++] = Wire.read();</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;I2CCommander::ReceiveHandler: chars read : &quot;</span>));</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    Serial.println(count, DEC);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">long</span> four = buf[0];</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">long</span> three = buf[1];</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">long</span> two = buf[2];</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">long</span> one = buf[3];</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="comment">//Rebuild the recomposed long by using bitshift.</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> foundID = ((four &lt;&lt; 0) &amp; 0xFF) + ((three &lt;&lt; 8) &amp; 0xFFFF) + ((two &lt;&lt; 16) &amp; 0xFFFFFF) + ((one &lt;&lt; 24) &amp; 0xFFFFFFFF);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> lastEventType = (<a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a>)buf[4];</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">int</span> foundData = buf[6];</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    foundData = foundData &lt;&lt; 8;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    foundData |= buf[5];</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(foundID, lastEventType, foundData);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <a class="code" href="classCommanders.html#a5805415d6f7e358f1b26b34e59fe89ac">Commanders::SetLastEventType</a>(lastEventType);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <a class="code" href="classCommanders.html#ac0885243a075244f75612900460d40ab">Commanders::SetLastEventData</a>(foundData);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    I2CLastEventId = foundID;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;}</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="classI2CCommanderClass.html#ac6575229251840ec767b7595e172ea1e">   55</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classI2CCommanderClass.html#ac6575229251840ec767b7595e172ea1e">I2CCommanderClass::begin</a>(uint8_t inSlaveID)</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;{</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    Wire.begin(inSlaveID);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    Wire.onReceive(OnReceiveHandler);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    this-&gt;I2CSlaveId = inSlaveID;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    I2CLastEventId = <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;}</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classI2CCommanderClass.html#a11fda5e10b4caf40275fea5854018808">   63</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classI2CCommanderClass.html#a11fda5e10b4caf40275fea5854018808">I2CCommanderClass::loop</a>()</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;{</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">if</span> (I2CLastEventId != <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    {</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">id</span> = I2CLastEventId;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        I2CLastEventId = <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keywordflow">return</span> id;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    }</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;}</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="classI2CCommanderClass.html#af6819052ca1a9dc32d07d2ad79be064e">   76</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classI2CCommanderClass.html#af6819052ca1a9dc32d07d2ad79be064e">I2CCommanderClass::printCommander</a>()</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;{</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;Commander: I2CCommander  - slave ID: &quot;</span>));</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    Serial.println(this-&gt;I2CSlaveId);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;}</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="ttc" id="classI2CCommanderClass_html_ac6575229251840ec767b7595e172ea1e"><div class="ttname"><a href="classI2CCommanderClass.html#ac6575229251840ec767b7595e172ea1e">I2CCommanderClass::begin</a></div><div class="ttdeci">void begin(uint8_t inI2CSlaveID)</div><div class="ttdef"><b>Definition:</b> <a href="I2CCommander_8cpp_source.html#l00055">I2CCommander.cpp:55</a></div></div>
<div class="ttc" id="classCommanders_html_ac0885243a075244f75612900460d40ab"><div class="ttname"><a href="classCommanders.html#ac0885243a075244f75612900460d40ab">Commanders::SetLastEventData</a></div><div class="ttdeci">static void SetLastEventData(int inData)</div><div class="ttdef"><b>Definition:</b> <a href="Commanders_8hpp_source.html#l00093">Commanders.hpp:93</a></div></div>
<div class="ttc" id="classCommanders_html_a5805415d6f7e358f1b26b34e59fe89ac"><div class="ttname"><a href="classCommanders.html#a5805415d6f7e358f1b26b34e59fe89ac">Commanders::SetLastEventType</a></div><div class="ttdeci">static void SetLastEventType(COMMANDERS_EVENT_TYPE inEvent)</div><div class="ttdef"><b>Definition:</b> <a href="Commanders_8hpp_source.html#l00089">Commanders.hpp:89</a></div></div>
<div class="ttc" id="classCommanders_html_a7adbe54da67e90e0d39b58d69ac3add0"><div class="ttname"><a href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a></div><div class="ttdeci">static unsigned long RaiseEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEvent = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Commanders_8cpp_source.html#l00027">Commanders.cpp:27</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490c"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00025">Events.h:25</a></div></div>
<div class="ttc" id="Events_8h_html_a48ad4dd16b8e22f2c8bc92b154479e92"><div class="ttname"><a href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a></div><div class="ttdeci">#define UNDEFINED_ID</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00038">Events.h:38</a></div></div>
<div class="ttc" id="classI2CCommanderClass_html_af6819052ca1a9dc32d07d2ad79be064e"><div class="ttname"><a href="classI2CCommanderClass.html#af6819052ca1a9dc32d07d2ad79be064e">I2CCommanderClass::printCommander</a></div><div class="ttdeci">void printCommander()</div><div class="ttdef"><b>Definition:</b> <a href="I2CCommander_8cpp_source.html#l00076">I2CCommander.cpp:76</a></div></div>
<div class="ttc" id="classI2CCommanderClass_html_a11fda5e10b4caf40275fea5854018808"><div class="ttname"><a href="classI2CCommanderClass.html#a11fda5e10b4caf40275fea5854018808">I2CCommanderClass::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="I2CCommander_8cpp_source.html#l00063">I2CCommander.cpp:63</a></div></div>
<div class="ttc" id="classI2CCommanderClass_html"><div class="ttname"><a href="classI2CCommanderClass.html">I2CCommanderClass</a></div><div class="ttdef"><b>Definition:</b> <a href="I2CCommander_8hpp_source.html#l00037">I2CCommander.hpp:37</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>I2CCommander.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
